//
//  Wall.m
//  Sectors
//
//  Created by Max Williams on 27/10/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "Wall.h"


@implementation Wall 

@synthesize a, b, normal, shared, floorHeight, ceilingHeight, sector, sharedSector, interWorld;

- (id)initWithPointA:(vec3)newA B:(vec3)newB {
	if ([super init]==nil) return nil;
	
	a = newA;
	b = newB;
	
	return self;
}

+ (Wall *)wallFrom:(vec3)newA to:(vec3)newB {
	Wall *wall = [[Wall alloc] initWithPointA:newA B:newB];
	return [wall autorelease];
}

- (int)sectorsNeededWithFloorHeight:(float)sectorFloorHeight ceilingHeight:(float)sectorCeilingHeight {
	int needed = 0;
	if (interWorld) return 0;
	if (sectorFloorHeight<floorHeight) needed++;
	if (sectorCeilingHeight>ceilingHeight) needed++;
	return needed;
}

- (void)drawStencil {
	// if (interWorld == NO) return;
	// glColor4f(1,1,1,0);
	// glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
	glBegin(GL_QUADS);
		glVertex3f(a.x,ceilingHeight,a.z);
		glVertex3f(b.x,ceilingHeight,b.z);
		glVertex3f(b.x,floorHeight,b.z);
		glVertex3f(a.x,floorHeight,a.z);			
	glEnd();
}

- (void)setNormal:(vec3)newNormal {
	normal = newNormal;
	clipPlane = calloc(sizeof(GLdouble),4);
	clipPlane[0] = -normal.x;
	clipPlane[1] = -normal.y;
	clipPlane[2] = -normal.z;
	clipPlane[3] = 0;
}

- (GLdouble *)clipPlane {
	return clipPlane;
}

@end
